/** distinput.c: input is a protein or dna distance matrix from PHYLIP/prodist
and dnadist **/

#include <stdio.h>
#include <string.h>
#include "sota.h"


void readMatrix2 (int setNo, int i, char *matrixLine, DATA *D)
{
	 real **sec;
	 int  j;
	 char *p;
	 double number;

	 sec = D->inputvector[i];

	 p = matrixLine;

	 for (j=0; j< D->numseq; j++) {
		while (isspace(*p)) p++;
		sscanf(p, "%lf", &number);
		sec[setNo][j] = number;
		if (*p == '\r') break;
		while ( !isspace(*p) ) p++;
	 }
}


/* -----------------------------
INPUT DATA:
----------------------------- */

int distinputvals( DATA *Datos )
{
	char line[255];

	if ( (Datos->fp = fopen( Datos->namein, "r" ))==NULL ) return( FALSE );
	fgets( line, 100, Datos->fp );
	if ( sscanf( line, "%d", &Datos->numseq )==1 ) {
		Datos->tamalfabeto = Datos->numseq;
		fclose (Datos->fp);
		return( TRUE );
	}
	fclose (Datos->fp);
	return( FALSE );
}

void distinputdata( DATA *Datos )
{
	int seqNo, dataSetNo, j;
	int size;      /** the number of bytes in each line of distance matrix  **/
	char *line, *p;
	char name[20], buf[255];

	#if defined(unix) || defined (__unix__) || defined (__unix)
		size = 15+Datos->tamalfabeto*9-1;
		#else
			size = 15+Datos->tamalfabeto*9;
	#endif

	if ( (line = (char *) malloc (sizeof(char) * size)) == NULL) {
		printf("no more memory!\n");
		exit (1);
	}

	for( seqNo=0; seqNo < Datos->numseq; seqNo++ ) {
		Datos->inputvector[seqNo] = (real **)new_matrix( Datos->numbases, Datos->tamalfabeto, sizeof(real) );
	}

	if ( (Datos->fp=fopen(Datos->namein,"rb")) == NULL ) {
		printf("Cannot open the input file!\n");
		exit (1);
	}

	for ( dataSetNo=0; dataSetNo<Datos->numbases; dataSetNo++) {
		if ( fgets( buf, 255, Datos->fp ) == NULL ) {
			printf("No (enough) data in the matrix file!\n");
			exit( 1 );
		}

		for( seqNo=0; seqNo < Datos->numseq; seqNo++ ) {
			fread (line,size,1,Datos->fp);
			sscanf (line,"%s",name);
			/** nombre de secuencia **/
			j = strlen( name );
			Datos->nombre[seqNo] = (char *) malloc( j+1 );
			strcpy( Datos->nombre[seqNo], name );
			if ( Datos->debug ) printf("%d Leida %s\n", seqNo, name );

			p = line+j;
			readMatrix2 (dataSetNo,seqNo,p,Datos);
		}
	}
	fclose ( Datos->fp );
	Datos->fp = NULL;
}
