/** matinput.c: input is 20*20 matrix   **/

#include <stdio.h>
#include <string.h>
#include "sota.h"

void readMatrix (int i,int rows, char *matrixLine, DATA *D)
{
	 real **sec;
	 int  j;
	 char *p;
	 double number;

	 sec = D->inputvector[i];

	 p = matrixLine;
	 for (j=0; j<D->numbases; j++) {
		while (isspace (*p)) p++;	/** ignore leading spaces **/
		 sscanf(p, "%lf", &number);
		 sec[rows][j] = number;
		 if (*p == '\0') break;
		 while (!isspace(*p)) p++;
	 }
}


/* -----------------------------
INPUT DATA:
----------------------------- */

int matinputvals( DATA *Datos )
{
	char line[255];

	if ( (Datos->fp = fopen( Datos->namein, "r" ))==NULL ) return( FALSE );
	fgets( line, 100, Datos->fp );
	if ( sscanf( line, "%d", &Datos->numseq )==1 )
		return( TRUE );
	return( FALSE );
}

void matinputdata( DATA *Datos )
{
	int seqNo, i, j;
	char line[255];
	char name[ 20 ];

	for( seqNo=0; seqNo < Datos->numseq; seqNo++ ) {
		if ( fgets( line, 255, Datos->fp ) == NULL ) {
			printf("Error 1!\n");
			exit( 1 );
		}
		Datos->inputvector[seqNo] =
			(real **)new_matrix( Datos->numbases, Datos->tamalfabeto, sizeof(real) );

		sscanf (line,"%s",name);
		/** nombre de secuencia **/
		j = strlen( name );
		Datos->nombre[seqNo] = (char *) malloc( j+1 );
		strcpy( Datos->nombre[seqNo], name );
		if ( Datos->debug ) printf("%d Leida %s\n", i, name );

		i = 0;
		while (i<Datos->numbases) {
				if (fgets(line,255,Datos->fp)==NULL){
					printf("Error 2\n");
					exit(1);
				}
			  readMatrix (seqNo,i,line,Datos);
			  i++;
		}

	}

	fclose ( Datos->fp );
	Datos->fp = NULL;
}

