/** 27-12-95    last updated  11-03-97  **/

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include "sota.h"

char mainmenu(DATA *D) {
	char modechar, *charp;
	char infile [64], outfile [64];

	printf( "SOTA: Self Organizing Tree Algorithm for Phylogenetic Analysis\n");
	printf( "Version %s\n", version );

	printf("\n\tAvailable options:\n\n");
	printf("\t1 Aligned sequence input (DNA or protein sequence)\n");
	printf("\t2 Composition input (protein dipeptide composition)\n");
	printf("\t3 Distance input (distance from phylip/protdist and dnadist)\n");

	printf("\nYour choice: "); fflush(stdout);	/* ++pac */
	modechar=getchar();
	while (modechar!='1' && modechar!='2' && modechar!='3') {
		modechar = getchar();
	}

	/** input and output file names  **/
	printf("\nPlease enter the input name: "); fflush(stdout);	/* ++pac */
	scanf("%s",infile);
	while ( fopen(infile,"r") == NULL) {
		printf("Please enter the input name: "); fflush(stdout);	/* ++pac */
		scanf("%s",infile);
	}
	strcpy(D->namein,infile);

	printf("Please enter the output name: "); fflush(stdout);	/* ++pac */
	scanf("%s",outfile);
	charp = outfile;
	do {
		if (isalnum(*charp) || (*charp=='.') )
			charp++;
		else {
			printf("Please enter the output name: "); fflush(stdout);	/* ++pac */
			scanf ("%s",outfile);
			charp = outfile;
		}
	} while (*charp != '\x0');

	while ( fopen(outfile,"w") == NULL) {
		printf("Cannot open an output file!");
		exit (0);
	}

	strcpy(D->nameout,outfile);

	return (modechar);
}


void argumentos ( char modea, DATA *Datos )
{
	static char ch;
	static char noyes[4]="No";        /** for debug the process   **/
	static char yesno[15]="Yes";     /** for the input format  **/
	static char seqType[8]="Protein";
	static char procesType[9]="Media";
	static int flag1=0;
	static int flag2=0;
	static int flag3=0;
	static int flag4=0;

  while ( 1 ) {

	clrscr(); 
/* ++pac */
#ifdef _PLAN9
        getchar();
#endif
	printf("Settings for this run:\n");
	printf("  M  maxiter0?\t\t\t\t\t%d\n",Datos->MaxIter0);
	printf("  T  threshold?\t\t\t\t\t%5.4f\n",Datos->umbral);
	printf("  R  final resource?\t\t\t\t%5.4f\n",Datos->RecFinal);
	printf("  L  slope?\t\t\t\t\t%5.4f\n",Datos->Nfinal);
	printf("  N  number of rondas?\t\t\t\t%d\n",Datos->NumRondas);
	printf("  C  number of tics?\t\t\t\t%d\n",Datos->tics);
	printf("  W  updating parameter for winner cell?\t%5.4f\n",Datos->eb);
	printf("  F  updating parameter for mather cell?\t%5.4f\n",Datos->ens);
	printf("  S  updating parameter for sister cell?\t%5.4f\n",Datos->enh);
	printf("  D  type of sequence (DNA, Protein)?\t\t%s\n",seqType);
	if (modea=='3') printf("  H  How many datasets?\t\t\t\t%d\n",Datos->numbases);
	if (modea=='1') printf("  I  input sequences interleaved?\t\t%s\n",yesno);
	printf("  O  process (Media, Varianza)?\t\t\t%s\n",procesType);
	printf("  P  print indications of progress of run?\t%s\n",noyes);
	printf("\nAre these settings correct? (type Y or letter for one to change)\n"); fflush(stdout);	/* ++pac */

	ch = getchar(); 
	ch = toupper (ch);

	switch (ch) {
			case 'M':
				printf("Please enter a value for maxinter0: "); fflush(stdout);	/* ++pac */
				scanf("%d",&Datos->MaxIter0);
				break;
			case 'T':
				printf("Please enter a value for threshold: "); fflush(stdout);	/* ++pac */
				scanf("%f",&Datos->umbral);
				break;
			case 'R':
				printf("Please enter a value for final resource: "); fflush(stdout);	/* ++pac */
				scanf("%f",&Datos->RecFinal);
				break;
			case 'L':
				printf("Please enter a value for slope: "); fflush(stdout);	/* ++pac */
				scanf("%f",&Datos->Nfinal);
				break;
			case 'N':
				printf("Please enter a value for number of rondas: "); fflush(stdout);	/* ++pac */
				scanf("%d",&Datos->NumRondas);
				break;
			case 'W':
				printf("Please enter a value for updating the winner cell: "); fflush(stdout);	/* ++pac */
				scanf("%f",&Datos->eb);
				break;
			case 'F':
				printf("Please enter a value for updating the mather cell: "); fflush(stdout);	/* ++pac */
				scanf("%f",&Datos->ens);
				break;
			case 'S':
				printf("Please enter a value for updating the sister cell: "); fflush(stdout);	/* ++pac */
				scanf("%f",&Datos->enh);
				break;
			case 'C':
				printf("Please enter a value for number of tics: "); fflush(stdout);	/* ++pac */
				scanf("%d",&Datos->tics);
				break;
			case 'D':
				if (flag1==0) {
					Datos->residuoposible = Base;
					Datos->tamalfabeto = 5;
					strcpy (seqType,"DNA");
					flag1=1;
					break;
				}
				else {
					Datos->residuoposible = Aminoacido;
					Datos->tamalfabeto = 21;
					strcpy (seqType,"Protein");
					flag1=0;
				}
				break;
			case 'H':
				printf("Please enter how many datasets for analysis: "); fflush(stdout);	/* ++pac */
				scanf("%d",&Datos->numbases);
				break;
			case 'I':
				if (flag3==0) {
					strcpy (yesno,"No, sequential");
					Datos->inputseqformat = sequential;
					flag3=1;
				}
				else {
					strcpy (yesno,"Yes");
					Datos->inputseqformat = interleaved;
					flag3=0;
				}
				break;
			case 'P':
				if (flag4==0) {
					Datos->debug = 1;
					strcpy (noyes,"Yes");
					flag4=1;
				}
				else {
					Datos->debug = 0;
					strcpy (noyes,"No");
					flag4=0;
				}
				break;
			case 'O':
				if (flag2==0) {
					Datos->recproc = Varianza;
					strcpy (procesType,"Varianza");
					flag2=1;
				}
				else {
					Datos->recproc = Media;
					strcpy (procesType,"Media");
					flag2=0;
				}
				break;
			case 'Y' : return;
			default: break;
	}
  }
}

