/** Global variables **/

#define TRUE   1
#define FALSE  0

extern char version[];
extern char BasePosible[];
extern char AacPosible[];
extern char ResidIndet[]; 
extern char ResidDel[];        

typedef float real;

typedef struct typecell *PCell;

typedef struct typecell {
	int id, indlist;    /** internal numeration **/
	int update;
	real **sec;
	PCell up, lef, rig; /* to set up the tree structure: pointers up (to ancestor)
			       lef (to left descendant) and rig (to right descendant) */
} Cell;

typedef struct listcells {
	int num;
	PCell * cells; 	
	PCell * rango;
	real * recursos;
	real * rec2;
	int * inputs;
} ListCells;

enum RecProc { Varianza, Media };      /* variance, mean */
enum TypeProc { Base, Aminoacido };    /* nucleotide, amino acid */
enum InputSeqFormat {interleaved, sequential}; /* two formats of phylip  */

/** One struct for all data interchanged and needed by the program **/
typedef struct {
	char namein[80];     
	char nameout[80];
	char namealias[80];
	int numseq;          /** Sequences Number. Set by arguments **/
	int numbases; 	     /** Number of bases **/ 
	int tamalfabeto;     /** nucleotide or Aminoacids = 5 or 21 **/
	enum TypeProc residuoposible;  /** = Aminoacid or Base **/
	enum RecProc recproc;          /** Varianza or Media **/
	enum InputSeqFormat inputseqformat;  /** interleaved or sequential  **/
    	unsigned long MaxIter;
	int MaxIter0, NumRondas;
	int fin, converge;
	int t, ttot, tr, tics, indice; 
	real eb, ens, enh;
	real umbral, Nfinal, fronda, RecFinal;
	real MaxRec, TotDist;
	int debug;

	PCell raiz;          /** Pointer to the tree root **/
	ListCells lcells;    /** Ponter to the list of cells */ 
	real *** inputvector;
	int * inputBMU;
	char ** nombre;      /** Pointer to readed secuences' names **/
	FILE *fp;            /** Files input output pointer **/
} DATA;


/** Prototype funtions **/

/** In seqinput.c **/
void ** new_matrix( int rows, int cols, int size );
int seqinputvals( DATA *datos );
void seqinputdata( DATA *datos );

/** In matinput.c  **/
int matinputvals( DATA *datos );
void matinputdata( DATA *datos );

/** In disinput.c  **/
int distinputvals( DATA *datos );
void distinputdata( DATA *datos );

/** In modebat.c **/
void argumentos ( char modea, DATA *Datos );

/* ++pac */
#ifdef _PLAN9
#define clrscr() 
#else
#define clrscr() system ("clear")
#endif
